#
# Conditional build:
%bcond_with	tests	# pytest tests
%bcond_without	doc	# Sphinx documentation

Summary:	The modular source code checker: pycodestyle, pyflakes and co.
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Name:		python-flake8
# Keep version < 4.x here as it is last version with python2 support
Version:	3.9.2
Release:	6
License:	MIT
Group:		Development/Tools
#Source0Download: https://pypi.org/simple/flake8/
Source0:	https://files.pythonhosted.org/packages/source/f/flake8/flake8-%{version}.tar.gz
# Source0-md5:	5c102972d3d0f35255c56a20613fcec5
Patch0:		flake8-duplicate.patch
URL:		https://gitlab.com/pycqa/flake8
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	rpm-pythonprov
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-setuptools >= 1:30
%if %{with tests}
BuildRequires:	python-configparser
BuildRequires:	python-enum34
BuildRequires:	python-functools32
BuildRequires:	python-importlib_metadata
%endif
BuildRequires:	python-mccabe >= 0.6.0
BuildRequires:	python-mccabe < 0.7.0
BuildRequires:	python-mock >= 2.0.0
BuildRequires:	python-pycodestyle >= 2.7.0
BuildRequires:	python-pycodestyle < 2.8.0
BuildRequires:	python-pyflakes >= 2.3.0
BuildRequires:	python-pyflakes < 2.4.0
BuildRequires:	python-pytest
BuildRequires:	python-typing
%if %{with doc}
BuildRequires:	python-sphinx-prompt
BuildRequires:	sphinx-pdg-2 >= 1.3
%endif
Requires:   python-mccabe >= 0.6.0
Requires:   python-mccabe < 0.7.0
Requires:   python-modules >= 1:2.7
Requires:   python-pycodestyle >= 2.7.0
Requires:   python-pycodestyle < 2.8.0
Requires:   python-pyflakes >= 2.3.0
Requires:   python-pyflakes < 2.4.0
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package apidocs
Summary:	API documentation for Python flake8 module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona flake8
Group:		Documentation

%description apidocs
API documentation for Python flake8 module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona flake8.

%prep
%setup -q -n flake8-%{version}
%patch -P 0 -p1

%build
%py_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(pwd)/src \
%{__python} -m pytest -rw tests
%endif

%if %{with doc}
cd docs/source
PYTHONPATH=$(pwd)/../../src \
sphinx-build-2 -b html . _build/html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py_install
%{__mv} $RPM_BUILD_ROOT%{_bindir}/flake8{,-2}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt LICENSE README.rst
%attr(755,root,root) %{_bindir}/flake8-2
%{py_sitescriptdir}/flake8
%{py_sitescriptdir}/flake8-%{version}-py*.egg-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/source/_build/html/{_modules,_static,internal,plugin-development,release-notes,user,*.html,*.js}
%endif
%changelog
* Mon Apr 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-flake8.git;a=log;h=master

* Mon Apr 07 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> bccabaf
- python2 only flake8

* Mon Apr 07 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> e584594
- Revert "- up to 7.2.0"

* Sun Apr 06 2025 Jan Rękorajski <baggins@pld-linux.org> da06396
- up to 7.2.0

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 83b6443
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 7446cf0
- use patch -P

* Fri Apr 01 2022 Jan Rękorajski <baggins@pld-linux.org> 1ae4453
- Release 3 (by relup.sh)

* Fri Apr 01 2022 Jan Rękorajski <baggins@pld-linux.org> bde5aaa
- disable tests, broken at least on python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 194a8cf
- rebuild with python 3.10

* Tue Mar 15 2022 Jakub Bogusz <qboosh@pld-linux.org> e6703be
- updated to 3.9.2
- removed obsolete req patch

* Mon Mar 01 2021 Jan Palus <atler@pld-linux.org> 9c76640
- explicit runtime deps on python-{entrypoints,mccabe,pycodestyle,pyflakes}; rel 3

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> a712f07
- release 2 (by relup.sh)

* Sun Jan 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 2fc1c08
- updated to 3.7.9
- added duplicate patch (fixes tests with python-flake8 already installed)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 74c2b4b
- rebuild with python 3.8
- release 2 (by relup.sh)

* Tue Oct 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 7b99a73
- added req patch: adjust entrypoints versions to be compatible with rpm dependency generators

* Tue Oct 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 1820387
- updated to 3.7.8
- removed outdated mock patch

* Sun Jul 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 34073ed
- updated to 3.5.0
- added -apidocs

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 975a3e6
- release 3 (by relup.sh)

* Mon Apr 17 2017 Jakub Bogusz <qboosh@pld-linux.org> d7cb1eb
- updated descriptions and dependencies
- added mock patch and sed substitution (use unittest.mock under python3)

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 972dfbb
- typo

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 5312367
- updated BRs
- rel 2

